/***************************************************************************
                          ksubeditordoc.h  -  description
                             -------------------
    begin                : sob sie  3 13:14:37 CEST 2002
    copyright            : (C) 2002 by Anatol Ogrek
    email                : mroova@linux.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#define SUB_INVALID   -1
#define SUB_MICRODVD  0
#define SUB_SUBRIP    1
#define SUB_SUBVIEWER 2
#define SUB_SAMI      3
#define SUB_VPLAYER   4
#define SUB_RT        5
#define SUB_SSA       6
#define SUB_DUNNOWHAT 7		// FIXME what format is it ?
#define SUB_MPSUB     8
#define SUB_AQTITLE   9
#define SUB_MAX_TEXT  3
#define LINE_LEN  1000


#ifndef KSUBEDITORDOC_H
#define KSUBEDITOR_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>
#include <klistview.h>
// include files for KDE
#include <kurl.h>

#include <microdvd.h>

#include "subtitles.h"
// forward declaration of the Ksubeditor classes
class KsubeditorView;

/**	KsubeditorDoc provides a document object for a document-view model.
  *
  * The KsubeditorDoc class provides a document object that can be used in conjunction with the classes
  * KsubeditorApp and KsubeditorView to create a document-view model for MDI (Multiple Document Interface)
  * KDE 2 applications based on KApplication and KTMainWindow as main classes and QWorkspace as MDI manager widget.
  * Thereby, the document object is created by the KsubeditorApp instance (and kept in a document list) and contains
  * the document structure with the according methods for manipulating the document
  * data by KsubeditorView objects. Also, KsubeditorDoc contains the methods for serialization of the document data
  * from and to files.
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 1.3 code generation
  */
class KsubeditorDoc : public QObject
{
  Q_OBJECT

  friend KsubeditorView;

  public:
    /** Constructor for the fileclass of the application */
    KsubeditorDoc();
    /** Destructor for the fileclass of the application */
    ~KsubeditorDoc();

    /** adds a view to the document which represents the document contents. Usually this is your main view. */
    void addView(KsubeditorView *view);
    /** removes a view from the list of currently connected views */
    void removeView(KsubeditorView *view);
		/** gets called if a view is removed or added */
		void changedViewList();
    /** returns the first view instance */
		KsubeditorView* firstView(){ return pViewList->first(); };
		/** returns true, if the requested view is the last view of the document */
    bool isLastView();
    /** This method gets called when the user is about to close a frame window. It checks, if more than one view
    	* is connected to the document (then the frame can be closed), if pFrame is the last view and the document is
    	* modified, the user gets asked if he wants to save the document.
    	*/
		bool canCloseFrame(KsubeditorView* pFrame);
    /** sets the modified flag for the document after a modifying action on the view connected to the document.*/
    void setModified(bool _m=true){ modified=_m; };
    /** returns if the document is modified or not. Use this to determine if your document needs saving by the user on closing.*/
    bool isModified(){ return modified; };
    /** deletes the document's contents */
    void deleteContents();
    /** initializes the document generally */
    bool newDocument();
    /** closes the acutal document */
    void closeDocument();
    /** loads the document by filename and format and emits the updateViews() signal */
    bool openDocument(const KURL &url, const int format=0);
    /** saves the document under filename and format.*/	
    bool saveDocument(const KURL &url, const int format=0);
    /** returns the KURL of the document */
    const KURL & URL() const;
    /** sets the URL of the document */
	  void setURL(const KURL &url);
  /** No descriptions */
  int typeDetect(const char *fname);
  /** Constructor for the fileclass of the application */
   KsubeditorDoc(KListView * list);
  /** No descriptions */
  void createSubtitle(int format);
  int sub_uses_time;
  /**  */
  subtitles * subtitle;
  /**  */
  int format;
  /**  */
  KURL movie_file;
  /**  */

	
  public slots:
    /** calls repaint() on all views connected to the document object and is called by the view by which the document has been changed.
     * As this view normally repaints itself, it is excluded from the paintEvent.
     */
    void updateAllViews(KsubeditorView *sender);
  /** No descriptions */
 	
  private:
    /** the modified flag of the current document */
    bool modified;
    KURL doc_url;
    /** the list of the views currently connected to the document */
    QList<KsubeditorView> *pViewList;	
    /**  */


};

#endif // KSUBEDITORDOC_H
