/***************************************************************************
                          subtitles.cpp  -  description
                             -------------------
    begin                : pi? sie 9 2002
    copyright            : (C) 2002 by Anatol Ogrek
    email                : mroova@linux.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#define SUB_INVALID   -1
#define SUB_MICRODVD  0
#define SUB_SUBRIP    1
#define SUB_SUBVIEWER 2
#define SUB_SAMI      3
#define SUB_VPLAYER   4
#define SUB_RT        5
#define SUB_SSA       6
#define SUB_DUNNOWHAT 7		// FIXME what format is it ?
#define SUB_MPSUB     8
#define SUB_AQTITLE   9
#define SUB_MAX_TEXT  3
#define LINE_LEN  1000



#include "subtitles.h"
#include "microdvd.h"
#include "vplayer.h"
#include "subripper.h"
subtitles::subtitles(int f,KListView *list){

  format = f;
  if (format == SUB_MICRODVD) micro = new microDVD(list);
  if (format == SUB_VPLAYER) v_player = new VPlayer(list);
  if (format == SUB_SUBRIP) sub_rip = new subRipper(list);
  fps = 25.0;
  Lista = list;
}
subtitles::~subtitles(){
  delete micro;

}
/** No descriptions */
bool subtitles::load(QString file){

  switch (format) {
    case  SUB_MICRODVD:
                         micro->load(file);
                                         check();
              return true;
              break;
    case  SUB_VPLAYER:   v_player->load(file);
                                         check();
              return true;
              break;
    case  SUB_SUBRIP:   sub_rip->load(file);
                                         check();
             return true;
              break;

    default:  return false;
            break;
  }

}
/** No descriptions */
bool subtitles::move_time(int secs, bool one ){
  switch (format) {
    case  SUB_MICRODVD:  if (micro->move_time(secs,one)) return true;
              break;
    case SUB_VPLAYER:    if (v_player->move_time(secs,one)) return true;
               break;
    case SUB_SUBRIP:    if (sub_rip->move_time(secs,one)) return true;
                break;
    default:
              return false;
            break;
  }
 return false;
}
/** No descriptions */
bool subtitles::convert(int dest, KListView * ListView, int fps){

  switch (format) {
    case SUB_MICRODVD: return micro->convert(dest,ListView);

                       break;
    case SUB_VPLAYER:  return v_player->convert(dest,ListView, fps);
                       break;
    case SUB_SUBRIP:  return sub_rip->convert(dest,ListView, fps);
                       break;

    default: return false;

  }
}
/** No descriptions */
bool subtitles::save(QString file){

switch (format) {
    case  SUB_MICRODVD:  return(micro->save(file));
              break;
    case  SUB_VPLAYER:   return(v_player->save(file));
              break;
    case  SUB_SUBRIP:    return(sub_rip->save(file));
             return true;
              break;

    default:
            break;
}
}/** No descriptions */
bool subtitles::check(){
  switch (format) {
    case  SUB_MICRODVD:  return(micro->check());
              break;
    case  SUB_VPLAYER:   return(v_player->check());
              break;
    case  SUB_SUBRIP:    return(sub_rip->check());
             return true;
              

    default:
            break;
}

}/** No descriptions */
bool subtitles::move_ms(int secs, bool one){

  switch (format) {
    case  SUB_MICRODVD:  if (micro->move_ms(secs,one)) return true;
              break;
    case SUB_SUBRIP:    if (sub_rip->move_ms(secs,one)) return true;
                break;
    default:
              return false;
            break;
  }          
}
